/* ccgo: goboard.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <gtk--.h>
#include <vector>
#include "gogame.hh"

class GoBoard :
	public Gtk::DrawingArea
{
public:
	enum Markings {
		NO_MARKING, LAST_MOVE, KO_SPACE, B_TERRI, W_TERRI
	};
	enum Trackings {
		TRACK_NONE, TRACK_STONES, TRACK_SPACE, TRACK_ALL
	};
	GoBoard(int);
	~GoBoard();
	SigC::Signal1<void, const Place &> hit;
	void put(const Place &, BoardStates);
	void mark(const Place &, Markings);
	void track(Trackings, BoardStates = NO_STONE);
	void clear();
	BoardStates get(const Place &);
private:
	const int z; // board size
	Board<BoardStates> b; // board array
	Board<Markings> m; // marking array

	Gdk_Window w;
	Gtk::Style * s;
	void realize_impl();
	gint expose_event_impl(GdkEventExpose *);
	gint enter_notify_event_impl(GdkEventCrossing *);
	gint leave_notify_event_impl(GdkEventCrossing *);
	gint motion_notify_event_impl(GdkEventMotion *);
	gint button_press_event_impl(GdkEventButton *);
	gint button_release_event_impl(GdkEventButton *);

	int tx; // tracker position
	int ty;
	bool ton; // tracker on
	bool mbd; // mouse button down
	Trackings t;
	BoardStates tf;
	void draw(int, int);
	void draw_track();
};
