/* ccgo: igs.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <sigc++/object.h>
#include "igsdata.hh"
#include "igsconn.hh"
#include "igsconsole.hh"
#include <regexx.hh>
#include <list>

class Igs :
	public Gtk::Window
{
public:
	Igs();
private:
	IgsConsole cons;
	IgsData data;
	IgsConn conn;
	regexx::Regexx rx;
	void (Igs::* parser)(const std::string &);
	int stage;
	int current_game;
	int * game_board;
	int game_size;
	std::string game_white;
	std::string game_black;
	void ps_init(const std::string &);
	std::string username;
	void enter_login();
	void ps_login(const std::string &);
	void ps_prompt(const std::string &);
	void ps_file(const std::string &);
	void ps_game(const std::string &);
	void ps_move(const std::string &);
	void ps_board(const std::string &);
	void ps_player(const std::string &);
	void ps_stats(const std::string &);
	std::string talker;
	void ps_kibitz(const std::string &);
	void ps_match(const std::string &);
	void sp_game_result(const std::string &);
	// handles;
	std::string * catch_enter;
	void enter_command(const std::string &);
	void float_command(std::string);
	void grab_line(const std::string &);
	void game_query(int);
	void moves_query(int);
	void unob_game(int);
	void observe_game(int);
	void stats_player(const std::string &);
	void send_move(const Place &);
	void send_undo();
	void send_pass();
	void send_done();
	void send_say(const std::string &);
	void send_kibitz(const std::string &, int);
	void game_list_query();
	void player_list_query();
	list<string> command_queue;
	void queue_command(const std::string &);
};
